#!/bin/bash

# upload changed zero install streams

set -x

# check whether feedlint works at all
FEEDLINT_WORKS=false
0launch -c 'http://0install.net/2007/interfaces/FeedLint.xml' -s http://simamo.de/0install/armagetronad-stable-dedicated-Linux-i486.xml && FEEDLINT_WORKS=true

function feedlint()
{
    test ${FEEDLINT_WORKS} = false || 0launch -c 'http://0install.net/2007/interfaces/FeedLint.xml' "$@"
#     0launch -c 'http://0install.net/2007/interfaces/FeedLint.xml' "$@"
}

pushd 0install
XMLS=$(bzr status | grep xml | sed -e 's,^ *,0install/,')
popd
#XMLS=$(ls 0install/*.xml | grep -v proto)

test -z "$XMLS" && { echo "Nothing changed."; exit 0; }

for XML in ${XMLS}; do
    feedlint ${XML} || exit 1

    if grep -v '\"0-pre' ${XML} | grep implementation.*version= > /dev/null 2>&1; then
        extraarg=""
        echo ${XML} | grep Windows > /dev/null 2>&1 && extraarg="--os=Windows -d"
        #echo ${XML} | grep x86_64 > /dev/null 2>&1 && extraarg="--cpu=x86_64 -d"
        echo ${XML} | grep i486 > /dev/null 2>&1 && extraarg="--cpu=i486 -d"
        echo ${XML} | egrep "libs|data|stable" > /dev/null 2>&1 && extraarg="-d"
        #0launch ${extraarg} -rcd ${XML} --version || exit 1
        0launch ${extraarg} -rc ${XML} --version || exit 1
    fi
done

#exit

$(dirname $0)/0install_upload.sh ${XMLS}
