#/bin/bash

set -x

. ./config.sh $*

function fail()
{
    Mak  echo fail
  false
}

function prepare()
{
    for f in ../release_64 ../release_32 ../winlibs ../ubunutu ../build_codeblocks; do
      if test -d $f; then
        pushd $f
        bzr pull
        popd
      fi
    done

    if test -d ../build_visualc; then
      pushd ../build_visualc
      svn update
      popd
    fi

    pushd ../armagetronad
    bzr revert
    bzr pull --overwrite
    extrabranches=extrabranches_$1
    for branch in ${!extrabranches}; do
        bzr merge ${branch} || return 1
	bzr commit -m "Merging from ${branch}"
    done
    popd

    pushd 0install
    bzr revert
    bzr pull --overwrite
    popd

    pushd ../
    make -f ../../Makefile.individual clean
    popd
}

function rel()
{
    f=$1
    pushd armagetronad > /dev/null 2>&1
  
    # check remote branches for changes
    somechange=false
    bzr missing --other || somechange=true
    extrabranches=extrabranches_$1
    for branch in ${!extrabranches}; do
        bzr missing --other ${branch} || somechange=true
    done
    popd > /dev/null 2>&1

    test ${somechange} = true || return 1
    
    pushd release_64 > /dev/null 2>&1
    for g in tarballs builds; do
        find $g -depth -ctime +8 -exec rm -rf \{\} \;
    done

    prepare $f
    popd > /dev/null 2>&1
}

# check for new releases
for f in $list; do
    pushd $f > /dev/null 2>&1
    rel $f
    popd > /dev/null 2>&1
done


