#!/bin/bash

# update zero install stream

set -x

make 0install uploadcheck
. make.conf
. builds/.versionfile
. builds/b_${VERSION}/.rc

remoteuser=manuel@kermit
builddir=/home/manuel/Tron/bzr/admin/release/remote/${VERSION}

# create environment
bzr push bzr+ssh://${remoteuser}/${builddir} --overwrite --no-strict --create-prefix || exit 1
bzr push -d 0install bzr+ssh://${remoteuser}/${builddir}/0install --overwrite --no-strict --create-prefix || exit 1
ssh ${remoteuser} "bzr reconfigure ${builddir} --tree"
ssh ${remoteuser} "bzr revert ${builddir}"
ssh ${remoteuser} "bzr update ${builddir}"
ssh ${remoteuser} "bzr reconfigure ${builddir}/0install --tree"
ssh ${remoteuser} "bzr revert ${builddir}/0install"
ssh ${remoteuser} "bzr update ${builddir}/0install"
ssh ${remoteuser} "mkdir -p ${builddir}/tarballs"  || exit 1
#ssh ${remoteuser} rm -f "${builddir}/tarballs/*"  || exit 1

# initialize
ssh ${remoteuser} "make -C ${builddir} nothing"

# build good make.conf
scp -Crp ${remoteuser}:${builddir}/make.conf make.conf.remote  || exit 1
grep -v OSTAG make.conf > make.conf.remote.new
grep    OSTAG make.conf.remote >> make.conf.remote.new
touch -r make.conf.remote make.conf.remote.new
scp -Crp make.conf.remote.new ${remoteuser}:${builddir}/make.conf  || exit 1
rm make.conf.remote*

# copy tarball
#scp -Cp builds/.versionfile* ${remoteuser}:${builddir}/builds/ || exit 1
rsync tarballs/*.tar ${remoteuser}:${builddir}/tarballs/ || exit 1

# init again
#ssh ${remoteuser} "make -C ${builddir} nothing"

# sync release names
#ssh ${remoteuser} "mkdir -p ${builddir}/builds/b_${VERSION}/B${RC}"  || exit 1
#scp -Cp builds/b_${VERSION}/.rc* ${remoteuser}:${builddir}/builds/b_${VERSION}/ || exit 1

# build
ssh ${remoteuser} ". /etc/profile; . /mybin/global/selectprofile oldgcc; make -C ${builddir} -j 3 generic_build -k" || exit 1
ssh ${remoteuser} ". /etc/profile; . /mybin/global/selectprofile oldgcc; make -C ${builddir} $@" || exit 1

# find remote build dir
scp -Crp ${remoteuser}:${builddir}/builds/.versionfile.proto versionfile.remote || exit 1
REMOTEVERSION=$(cat versionfile.remote)
scp -Crp ${remoteuser}:${builddir}/builds/b_${REMOTEVERSION}/.rc.base rc.remote || exit 1
REMOTERC=$(cat rc.remote)
rm *.remote

# commit and pull back
ssh ${remoteuser} "cd ${builddir}; bzr commit 0install" -m "Updated"
pushd 0install
if bzr missing bzr+ssh://${remoteuser}/${builddir}/0install; then
  echo "Nothing to pull back"
else
  bzr pull bzr+ssh://${remoteuser}/${builddir}/0install || exit 1
  bzr uncommit --force
fi
popd

# copy resulting build files
scp -Crp ${remoteuser}:${builddir}/builds/b_${REMOTEVERSION}/B${REMOTERC}/Upload/* builds/b_${VERSION}/B${RC}/Upload/ || exit 1
#rm -f builds/b_${VERSION}/B${RC}/.*.0installtag
